
QGIS Application - Bug report #15341

Inside perimeter polygon labelling not right

2016-07-25 10:47 PM - Frits van Veen

Status: Closed

Priority: Normal

Assignee:

Category: Unknown

Affected QGIS version:2.16.0 Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 23273

Description

A polygon is clipped (for presumeably performance reasons) to the visible area before labelling is applied.

If the resulting polygon is a simple one, all works well. If it is a multipolygon (see the extra edges at the bottom of the view) only one label is

plotted and it is on the wrong side of the polygon.

Settings:

Placement: Using Perimeter

Allowed positions: Below line / Line orientation dependent position checked

Repeat: 100 mm

Associated revisions

Revision c0b16840 - 2016-07-27 03:02 AM - Frits van Veen

Fix labeling using perimeter with repeating label distance set

If the visible part of a polygon is clipped and becomes a multipolygon, only

one label is plotted on the wrong side of the polygon.

Settings:

Placement: Using Perimeter

Allowed positions: Below line / Line orientation dependent position checked

Repeat: 100 mm

Fix #15341

Revision b2fb248a - 2016-07-27 06:17 AM - Nyall Dawson

Fix labeling using perimeter with repeating label distance set

If the visible part of a polygon is clipped and becomes a multipolygon, only

one label is plotted on the wrong side of the polygon.

Settings:

Placement: Using Perimeter

Allowed positions: Below line / Line orientation dependent position checked

Repeat: 100 mm

Fix #15341
(cherry-picked from c0b1684058a5acf3ae58ea63bea7b00520e27725)

Revision 3f331900 - 2016-07-27 06:51 AM - Nyall Dawson

Fix labeling using perimeter with repeating label distance set

If the visible part of a polygon is clipped and becomes a multipolygon, only

one label is plotted on the wrong side of the polygon.

Settings:

Placement: Using Perimeter

Allowed positions: Below line / Line orientation dependent position checked

Repeat: 100 mm

Fix #15341

(cherry-picked from c0b1684058a5acf3ae58ea63bea7b00520e27725)

Revision bfa77141 - 2016-07-30 01:22 AM - Nyall Dawson

Fix labeling using perimeter with repeating label distance set

If the visible part of a polygon is clipped and becomes a multipolygon, only

one label is plotted on the wrong side of the polygon.

Settings:

Placement: Using Perimeter

Allowed positions: Below line / Line orientation dependent position checked

Repeat: 100 mm

Fix #15341

(cherry-picked from c0b1684058a5acf3ae58ea63bea7b00520e27725)

History

#1 - 2016-07-26 05:34 AM - Frits van Veen

- File Inside_perimeter_multipolygon_labelling_-_fixed.png added

I've got a fix!

in QgsPalLayerSettings::registerFeature line 2520 I changed

  if ( GEOSGeomTypeId_r( QgsGeometry::getGEOSHandler(), geos_geom )  GEOS_POLYGON && repeatDistance > 0 && placement  Line )

to

  GEOSGeomTypes geomType = (GEOSGeomTypes) GEOSGeomTypeId_r( QgsGeometry::getGEOSHandler(), geos_geom );

  if ( (geomType  GEOS_POLYGON || geomType  GEOS_MULTIPOLYGON) && repeatDistance > 0 && placement == Line )

#2 - 2016-07-26 06:03 PM - Frits van Veen

- Status changed from Open to Closed
Fixed in changeset commit:"c0b1684058a5acf3ae58ea63bea7b00520e27725".

#3 - 2017-09-22 09:55 AM - Jürgen Fischer

- Category set to Unknown
